--------------------------------------------------------------------------------
-- Company: <Name>
--
-- File: send_xcvr_8b10b.vhd
-- File history:
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--
-- Description: 
--
-- <Description here>
--
-- Targeted device: <Family::PolarFire> <Die::MPF300T_ES> <Package::FCG1152>
-- Author: <Name>
--
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_arith.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

entity send_xcvr_8b10b is

    port(
        clk      : in  std_logic;
        rstn     : in  std_logic;
        data_in  : in  std_logic_vector(7 downto 0); -- Byte from UART
        data_out : out std_logic_vector(15 downto 0);
        k_out    : out std_logic_vector(1 downto 0);
start : in  std_logic
    );

end send_xcvr_8b10b;

architecture architecture_send_xcvr_8b10b of send_xcvr_8b10b is



    type   SEND_TYPE is (K_STATE,
                         S0_STATE,
                         S1_STATE,
                         S2_STATE,
                         S3_STATE,
                         S4_STATE,
                         S5_STATE,
                         S6_STATE
                         );
    signal send_state : SEND_TYPE;  -- State Register

    signal cnt1  : std_logic_vector(15 downto 0);
    signal cnt2  : std_logic_vector(15 downto 0);

    signal treg0  : std_logic_vector(15 downto 0);
    signal treg1  : std_logic_vector(15 downto 0);
    signal treg2  : std_logic_vector(15 downto 0);
    signal treg3  : std_logic_vector(15 downto 0);

    signal st_sync  : std_logic_vector(2 downto 0);
    
begin

syncP:process(clk, rstn)
    begin
        if (rstn = '0')then
            st_sync<="000";
        elsif (clk'event and clk = '1') then
            st_sync<=st_sync(1 downto 0) & start;
        end if;
    end process syncP;    
  

sendP:process(clk, rstn)
    begin
        if (rstn = '0')then
            send_state <= K_STATE;
            data_out <= X"BCBC";
            cnt1 <= X"0000";
            cnt2 <= X"0000";
            k_out <= "11";
            treg0 <=  X"0123";
            treg1 <=  X"4567";
            treg2 <=  X"89AB";
            treg3 <=  X"CDEF";
        elsif (clk'event and clk = '1') then
            case send_state is
                --  idle 
                when K_STATE =>
                    data_out <= X"BCBC";
                    k_out <= "11";
                    if(st_sync(2) /= st_sync(1))then
                        send_state <= S0_STATE;
                        cnt1 <= cnt1 + 1;
                        if(cnt1 = X"FFFF")then
                            cnt2 <= cnt2 + 1;
                        end if;
                    end if;
                when S0_STATE =>
                    data_out <= treg0;
                    k_out <= "00";
                    send_state <= S1_STATE;
                when S1_STATE =>
                    data_out <= treg1;
                    k_out <= "00";
                    send_state <= S2_STATE;
                when S2_STATE =>
                    data_out <= treg2;
                    k_out <= "00";
                    send_state <= S3_STATE;
                when S3_STATE =>
                    data_out <= treg3;
                    k_out <= "00";
                    send_state <= S4_STATE;
                when S4_STATE =>
                    data_out <= data_in & data_in;
                    k_out <= "00";
                    send_state <= S5_STATE;
                when S5_STATE =>
                    data_out <= cnt2;
                    k_out <= "00";
                    send_state <= S6_STATE;
                when S6_STATE =>
                    data_out <= cnt1;
                    k_out <= "00";
                    send_state <= K_STATE;
                when others =>
                    send_state <= K_STATE;
            end case;
        end if;
    end process sendP;    
    
end architecture_send_xcvr_8b10b;
